#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

#include "copier.h"
/*  usage:  redirection "<nom_source" ">nom_cible"
 *          redirection  ">nom_cible" "<nom_source"
 *  copie le fichier nom_source vers nom_cible
 */

int main(int argc, char** argv){
  int source, cible;
  char *nom_source;
  char *nom_cible;
  struct stat stat_source;
  mode_t mode=0000;
  int i;

  for(i=1; i<argc; i++){
    if( argv[i][0] == '<' ){
      nom_source=argv[i]+1;
      source = open(nom_source,O_RDONLY);
      if( source < 0 ){
	perror(NULL);
	exit(EXIT_FAILURE);
      }
      close(STDIN_FILENO);
      if( dup(source) == -1 ){
	perror(NULL);
	exit(EXIT_FAILURE);
      }
      if( fstat(source,&stat_source) != -1 ){
	mode = stat_source.st_mode;
      }
    }
  }

  for(i=1; i<argc; i++){
    if( argv[i][0] == '>' ){
      nom_cible=argv[i]+1;
      cible = open(nom_cible,O_WRONLY|O_CREAT|O_TRUNC,mode);
      if( cible < 0 ){
	perror(NULL);
	exit(EXIT_FAILURE);
      }
      close(STDOUT_FILENO);
      if( dup(cible) == -1 ){
	perror(NULL);
	exit(EXIT_FAILURE);
      }
    }
  }

  if( copier() == -1 )
    exit(EXIT_FAILURE);

  exit(EXIT_SUCCESS);
}
